#include "des.h"

void Encrypt(char* Key, char* Msg, char* Ret, int size)
{
        DES_cblock KEY, IV;
        DES_key_schedule schedule;
        /* Prepare the key for use with DES_ecb_encrypt */
        memcpy(KEY, Key, 8);
        memcpy(IV, Key, 8);
        DES_set_odd_parity(&KEY);
        DES_set_key_checked(&KEY, &schedule);
        /* Decryption occurs here */
        DES_cbc_encrypt((unsigned char*) Msg, (unsigned char*) Ret, size, &schedule, IV, DES_ENCRYPT);
}

void Decrypt(char* Key, char* Msg, char* Ret, int size)
{
        DES_cblock KEY, IV;
        DES_key_schedule schedule;
        /* Prepare the key for use with DES_ecb_encrypt */
        memcpy(KEY, Key, 8);
        memcpy(IV, Key, 8);
        DES_set_odd_parity(&KEY);
        DES_set_key_checked(&KEY, &schedule);
        /* Decryption occurs here */
        DES_cbc_encrypt((unsigned char*) Msg, (unsigned char*) Ret, size, &schedule, IV, DES_DECRYPT);
}
